# coding: utf-8

"""
    VMware Aria Automation Assembler IaaS API

    IAAS API is a RESTful service, which allows users to execute provisioning related UI actions via an API.  This page describes the RESTful APIs for IAAS API. The APIs facilitate CRUD operations on the various resources and entities used throughout VMware Aria Automation Assembler(Cloud Accounts, Cloud zones, Computes, Mappings, etc.) and allows operations on them (creating a cloud account, patching a machine, creating image progile, etc.).  The APIs that list collections of resources also support OData like implementation. Below query params can be used across different IAAS API endpoints  Example: 1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.     ```/iaas/api/cloud-accounts?$orderby=name%20desc```  2. `$top` -  number of records you want to get.     ```/iaas/api/cloud-accounts?$top=20```  3. `$skip` -  number of records you want to skip.      ```/iaas/api/cloud-accounts?$skip=10```  4. `$select` - select a subset of properties to include in the response.        ```/project-service/api/projects?$top=10&$skip=2```  5. `$filter` -  filter the results by a specified predicate expression. Operators: eq, ne, and, or.\\     ```/iaas/api/cloud-accounts?$filter=name%20eq%20'ABC*'``` - name starts with 'ABC'\\     ```/iaas/api/cloud-accounts?$filter=name%20eq%20'*ABC*'``` - name contains 'ABC'\\     ```/iaas/api/cloud-accounts?$filter=name%20eq%20'*ABC'``` - name ends with 'ABC'\\     /iaas/api/projects and /iaas/api/deployments support different format for partial match:\\     ```/iaas/api/projects?$filter=startswith(name, 'ABC')``` - name starts with 'ABC'\\     ```/iaas/api/projects?$filter=substringof('ABC', name``` - name contains 'ABC'\\     ```/iaas/api/projects?$filter=endswith(name, 'ABC')``` - name ends with 'ABC'\\     ```/iaas/api/cloud-accounts?$filter=name%20ne%20'example-cloud-account'%20or%20customProperties.isExternal%20eq%20'false'```  6. `$count` -  flag which when specified, regardless of the assigned value, shows the total number of records. If the collection has a filter it shows the number of records matching the filter.\\     ```/iaas/api/cloud-accounts?$count=true```   # noqa: E501

    OpenAPI spec version: 2021-07-15
    Contact: sales@vmware.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class NetworkInterfaceSpecification(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'name': 'str',
        'description': 'str',
        'device_index': 'int',
        'network_id': 'str',
        'fabric_network_id': 'str',
        'addresses': 'list[str]',
        'mac_address': 'str',
        'security_group_ids': 'list[str]',
        'custom_properties': 'dict(str, str)'
    }

    attribute_map = {
        'name': 'name',
        'description': 'description',
        'device_index': 'deviceIndex',
        'network_id': 'networkId',
        'fabric_network_id': 'fabricNetworkId',
        'addresses': 'addresses',
        'mac_address': 'macAddress',
        'security_group_ids': 'securityGroupIds',
        'custom_properties': 'customProperties'
    }

    def __init__(self, name=None, description=None, device_index=None, network_id=None, fabric_network_id=None, addresses=None, mac_address=None, security_group_ids=None, custom_properties=None):  # noqa: E501
        """NetworkInterfaceSpecification - a model defined in Swagger"""  # noqa: E501
        self._name = None
        self._description = None
        self._device_index = None
        self._network_id = None
        self._fabric_network_id = None
        self._addresses = None
        self._mac_address = None
        self._security_group_ids = None
        self._custom_properties = None
        self.discriminator = None
        if name is not None:
            self.name = name
        if description is not None:
            self.description = description
        if device_index is not None:
            self.device_index = device_index
        if network_id is not None:
            self.network_id = network_id
        if fabric_network_id is not None:
            self.fabric_network_id = fabric_network_id
        if addresses is not None:
            self.addresses = addresses
        if mac_address is not None:
            self.mac_address = mac_address
        if security_group_ids is not None:
            self.security_group_ids = security_group_ids
        if custom_properties is not None:
            self.custom_properties = custom_properties

    @property
    def name(self):
        """Gets the name of this NetworkInterfaceSpecification.  # noqa: E501

        A human-friendly name used as an identifier in APIs that support this option.  # noqa: E501

        :return: The name of this NetworkInterfaceSpecification.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this NetworkInterfaceSpecification.

        A human-friendly name used as an identifier in APIs that support this option.  # noqa: E501

        :param name: The name of this NetworkInterfaceSpecification.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def description(self):
        """Gets the description of this NetworkInterfaceSpecification.  # noqa: E501

        A human-friendly description.  # noqa: E501

        :return: The description of this NetworkInterfaceSpecification.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this NetworkInterfaceSpecification.

        A human-friendly description.  # noqa: E501

        :param description: The description of this NetworkInterfaceSpecification.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def device_index(self):
        """Gets the device_index of this NetworkInterfaceSpecification.  # noqa: E501

        The device index of this network interface.  # noqa: E501

        :return: The device_index of this NetworkInterfaceSpecification.  # noqa: E501
        :rtype: int
        """
        return self._device_index

    @device_index.setter
    def device_index(self, device_index):
        """Sets the device_index of this NetworkInterfaceSpecification.

        The device index of this network interface.  # noqa: E501

        :param device_index: The device_index of this NetworkInterfaceSpecification.  # noqa: E501
        :type: int
        """

        self._device_index = device_index

    @property
    def network_id(self):
        """Gets the network_id of this NetworkInterfaceSpecification.  # noqa: E501

        Id of the network for the network interface. Either networkId or fabricNetworkId can be specified, not both.  # noqa: E501

        :return: The network_id of this NetworkInterfaceSpecification.  # noqa: E501
        :rtype: str
        """
        return self._network_id

    @network_id.setter
    def network_id(self, network_id):
        """Sets the network_id of this NetworkInterfaceSpecification.

        Id of the network for the network interface. Either networkId or fabricNetworkId can be specified, not both.  # noqa: E501

        :param network_id: The network_id of this NetworkInterfaceSpecification.  # noqa: E501
        :type: str
        """

        self._network_id = network_id

    @property
    def fabric_network_id(self):
        """Gets the fabric_network_id of this NetworkInterfaceSpecification.  # noqa: E501

        Id of the fabric network for the network interface. Either networkId or fabricNetworkId can be specified, not both.  # noqa: E501

        :return: The fabric_network_id of this NetworkInterfaceSpecification.  # noqa: E501
        :rtype: str
        """
        return self._fabric_network_id

    @fabric_network_id.setter
    def fabric_network_id(self, fabric_network_id):
        """Sets the fabric_network_id of this NetworkInterfaceSpecification.

        Id of the fabric network for the network interface. Either networkId or fabricNetworkId can be specified, not both.  # noqa: E501

        :param fabric_network_id: The fabric_network_id of this NetworkInterfaceSpecification.  # noqa: E501
        :type: str
        """

        self._fabric_network_id = fabric_network_id

    @property
    def addresses(self):
        """Gets the addresses of this NetworkInterfaceSpecification.  # noqa: E501

        A list of IP addresses allocated or in use by this network interface.  # noqa: E501

        :return: The addresses of this NetworkInterfaceSpecification.  # noqa: E501
        :rtype: list[str]
        """
        return self._addresses

    @addresses.setter
    def addresses(self, addresses):
        """Sets the addresses of this NetworkInterfaceSpecification.

        A list of IP addresses allocated or in use by this network interface.  # noqa: E501

        :param addresses: The addresses of this NetworkInterfaceSpecification.  # noqa: E501
        :type: list[str]
        """

        self._addresses = addresses

    @property
    def mac_address(self):
        """Gets the mac_address of this NetworkInterfaceSpecification.  # noqa: E501

        MAC address of the network interface.  # noqa: E501

        :return: The mac_address of this NetworkInterfaceSpecification.  # noqa: E501
        :rtype: str
        """
        return self._mac_address

    @mac_address.setter
    def mac_address(self, mac_address):
        """Sets the mac_address of this NetworkInterfaceSpecification.

        MAC address of the network interface.  # noqa: E501

        :param mac_address: The mac_address of this NetworkInterfaceSpecification.  # noqa: E501
        :type: str
        """

        self._mac_address = mac_address

    @property
    def security_group_ids(self):
        """Gets the security_group_ids of this NetworkInterfaceSpecification.  # noqa: E501

        A list of security group ids which this network interface will be assigned to.  # noqa: E501

        :return: The security_group_ids of this NetworkInterfaceSpecification.  # noqa: E501
        :rtype: list[str]
        """
        return self._security_group_ids

    @security_group_ids.setter
    def security_group_ids(self, security_group_ids):
        """Sets the security_group_ids of this NetworkInterfaceSpecification.

        A list of security group ids which this network interface will be assigned to.  # noqa: E501

        :param security_group_ids: The security_group_ids of this NetworkInterfaceSpecification.  # noqa: E501
        :type: list[str]
        """

        self._security_group_ids = security_group_ids

    @property
    def custom_properties(self):
        """Gets the custom_properties of this NetworkInterfaceSpecification.  # noqa: E501

        Additional properties that may be used to extend the base type.  # noqa: E501

        :return: The custom_properties of this NetworkInterfaceSpecification.  # noqa: E501
        :rtype: dict(str, str)
        """
        return self._custom_properties

    @custom_properties.setter
    def custom_properties(self, custom_properties):
        """Sets the custom_properties of this NetworkInterfaceSpecification.

        Additional properties that may be used to extend the base type.  # noqa: E501

        :param custom_properties: The custom_properties of this NetworkInterfaceSpecification.  # noqa: E501
        :type: dict(str, str)
        """

        self._custom_properties = custom_properties

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(NetworkInterfaceSpecification, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, NetworkInterfaceSpecification):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
